#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <machine.h>

void xpm_encode(char * bufenc, char * encoder, int enc_len, int n_char, int n)
{
   int j;
   bufenc[n_char]=0;
   for(j=n_char-1;j>=0;j--)
   {
      bufenc[j]=encoder[n % enc_len];
      n/=enc_len;
   }
}

//This function implements the conversion from array to xpm picture
void C2F (carr2xpm) (double * array, int *r_a, int *c_a,
   double * cmap, int *r_c, int*c_c,
   char * aFileName, int * NameLength,
   double * result)
{
   FILE * Fhnd;
   char buf[200];
   char filebuf[10000];
   //   char FileName[(*NameLength)+1];
   char FileName[256];
   char encoder[]=".abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
   char bufenc[256];
   double a_min, a_max; //Minimum and maximum values in the converted array
   int  enc_len; //length of the encoder table
   int i,j;
   int n_char; //encoding length
   if(*c_c != 3)
   {
      sprintf(buf,"The colormap must be 3-column matrix");
      cerro(buf);
      return;
   }
   //We calculate the encoding Length
   {
      int tmp_n;
      enc_len=strlen(encoder);
      tmp_n=enc_len;
      n_char=1;
      while (tmp_n < (*r_c))
      {
	 tmp_n=tmp_n*enc_len;
	 n_char++;
      }
   }
   for(i=0;i<(*NameLength);i++) FileName[i]=aFileName[i];
   FileName[i]=0;
   Fhnd = fopen(FileName,"wb");
   if(Fhnd == NULL)
   {
      sprintf(buf,"I can't open file: %s",FileName);
      cerro(buf);
      return;
   }
   setvbuf(Fhnd,filebuf,_IOFBF,10000);
   fprintf(Fhnd,"/* XPM */\n"
      "static char *test[] = {\n"
      "/* width height num_colors chars_per_pixel */\n");
   fprintf(Fhnd,"\" %d %d %d %d\",\n",*c_a,*r_a,*r_c,n_char);
   fprintf(Fhnd,"/* colors */\n");
   for(i=0;i<(*r_c);i++)
   {
      xpm_encode(bufenc,encoder,enc_len,n_char,i);
      fprintf(Fhnd,"\"%s c #%2.2x%2.2x%2.2x\",\n",bufenc,
	 (int)(255*cmap[i]),
	 (int)(255*cmap[(*r_c)+i]),
	 (int)(255*cmap[(*r_c)*2+i]));
   }
   fprintf(Fhnd,"/* pixels */\n");
   //We are calculating the minimum and maximum
   a_min=array[0];
   a_max=array[0];
   for(i=0;i<(*r_a);i++)
      for(j=0;j<(*c_a);j++)
      {
	 double tmp=array[j*(*r_a)+i];
	 if(tmp<a_min) a_min=tmp;
	 if(tmp>a_max) a_max=tmp;
      }
   for(i=0;i<(*r_a);i++)
   {
      fprintf(Fhnd,"\"");
      for(j=0;j<(*c_a);j++)
      {
	 int val = (array[j*(*r_a)+i]-a_min)*(*r_c)/(a_max-a_min);
	 xpm_encode(bufenc,encoder,enc_len,n_char,val);
	 fprintf(Fhnd,"%s",bufenc);
      }
      fprintf(Fhnd,"\"");
      if(i<(*r_a)-1) fprintf(Fhnd,",");
      fprintf(Fhnd,"\n");
   }
   fprintf(Fhnd,"};");
   fclose(Fhnd);
   (*result)=1;
} 
